#include <windows.h>
#include <commctrl.h>
#include <process.h>
#include "shellutil.h"
#include "cmpcode.h"
#include "resource.h"

#pragma comment(lib, "cmpcode.lib")
#pragma comment(lib, "comctl32.lib")

UINT	g_typeEncode = 0;	// ÍtOi0:Í̂݁A1:k̂݁A2:Íƈkj
UINT	g_typeExt = 0;		// gqtOi0:QA1:PA2:wj
UINT	g_typeSaveDir = 0;	// ۑtOi0:fXNgbvA1:wj
UINT	g_key = 0;			// ÍEL[
char	g_strExt[_MAX_EXT];	// gq

void Save_File(void *pv)
{
	HWND	hDlg = (HWND) pv;
	char	filenameSave[MAX_PATH];
	char	filenameShow[MAX_PATH];
	char	fname[_MAX_FNAME];
	char	ext[_MAX_EXT];
	char	strTitle[256];
	int		i;
	int		*pFileSize = (int*) malloc(sizeof(int) * (__argc - 1));
	int		nTotalSize = 0;
	for(i=1; i<__argc; i++){
		HANDLE  hFile;
		hFile = CreateFile(__argv[i],GENERIC_READ,FILE_SHARE_READ,
							NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(hFile == INVALID_HANDLE_VALUE){
			continue;
		}
		DWORD size = GetFileSize(hFile, NULL);
		if(size > 0 && size != 0xFFFFFFFF){
			pFileSize[i - 1] = size;
			nTotalSize += size;
		}
		CloseHandle(hFile);
	}
	int nAddSize = 0;
	for(i=1; i<__argc; i++){
		switch (g_typeExt)
		{
		case 0:	// Q
			_splitpath(__argv[i], NULL, NULL, NULL, g_strExt);
			if(strlen(g_strExt) < 2){
				strcpy(g_strExt, "");
			}
			else{
				int len = strlen(g_strExt);
				g_strExt[len - 2] = '\0';
				g_strExt[len - 1] = '\0';
			}
			break;
		case 1:	// P
			_splitpath(__argv[i], NULL, NULL, NULL, g_strExt);
			if(strlen(g_strExt) >= 1){
				g_strExt[strlen(g_strExt) - 1] = '\0';
			}
			break;
		}
		if(g_strExt[0] == '.'){
			char ext2[_MAX_EXT];
			strncpy(ext2, g_strExt + 1, sizeof(ext2));
			strncpy(g_strExt, ext2, sizeof(g_strExt));
		}
		_splitpath(__argv[i], NULL, NULL, fname, ext);
		strncpy(filenameSave, __argv[i], sizeof(filenameSave));
		sprintf(filenameSave, "%s\\%s.%s", g_path, fname, g_strExt);
		sprintf(filenameShow, "%s%s", fname, ext);
		SendDlgItemMessage(hDlg, IDC_STATIC1, WM_SETTEXT, 0, (LPARAM) filenameShow);
		Encode_File(g_typeEncode, g_key, filenameSave, __argv[i]);
		nAddSize += pFileSize[i - 1];
		int nProgress = nAddSize * 100 / nTotalSize;
		SendDlgItemMessage(hDlg, IDC_PROGRESS1, PBM_SETPOS, nProgress, 0);
		sprintf(strTitle, "RPGEncoder %d %% (c: %d)", nProgress, __argc - 1 - i);
		SendMessage(hDlg, WM_SETTEXT, 0, (LPARAM) strTitle);
	}
	free(pFileSize);
	SendMessage(hDlg, WM_CLOSE, 0, 0);
}

int CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HWND	hEdit[2];	// GfBbg nh
	static HWND	hBtn;		// {^ nh

	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			hEdit[0] = GetDlgItem(hDlg, IDC_EDIT1);
			hEdit[1] = GetDlgItem(hDlg, IDC_EDIT2);
			hBtn     = GetDlgItem(hDlg, IDC_BUTTON1);
			if(g_typeExt < 2){
				EnableWindow(hEdit[0], FALSE);
			}
			if(g_typeSaveDir == 0){
				EnableWindow(hEdit[1], FALSE);
				EnableWindow(hBtn, FALSE);
			}
			switch (g_typeEncode)
			{
			case 0:	// Í̂
				CheckRadioButton(hDlg, IDC_RADIO1, IDC_RADIO3, IDC_RADIO1);
				break;
			case 1:	// k̂
				CheckRadioButton(hDlg, IDC_RADIO1, IDC_RADIO3, IDC_RADIO2);
				break;
			case 2:	// Íƈk
				CheckRadioButton(hDlg, IDC_RADIO1, IDC_RADIO3, IDC_RADIO3);
				break;
			}
			switch (g_typeExt)
			{
			case 0:	// Q
				CheckRadioButton(hDlg, IDC_RADIO4, IDC_RADIO6, IDC_RADIO4);
				break;
			case 1:	// P
				CheckRadioButton(hDlg, IDC_RADIO4, IDC_RADIO6, IDC_RADIO5);
				break;
			case 2:	// w
				CheckRadioButton(hDlg, IDC_RADIO4, IDC_RADIO6, IDC_RADIO6);
				break;
			}
			switch (g_typeSaveDir)
			{
			case 0:	// fXNgbv
				CheckRadioButton(hDlg, IDC_RADIO7, IDC_RADIO8, IDC_RADIO7);
				break;
			case 1:	// w
				CheckRadioButton(hDlg, IDC_RADIO7, IDC_RADIO8, IDC_RADIO8);
				break;
			}
			SendMessage(hEdit[0], WM_SETTEXT, 0, (LPARAM) g_strExt);
			SendMessage(hEdit[1], WM_SETTEXT, 0, (LPARAM) g_path);
		}
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDC_RADIO1:	// Í̂
			g_typeEncode = 0;
			break;
		case IDC_RADIO2:	// k̂
			g_typeEncode = 1;
			break;
		case IDC_RADIO3:	// Íƈk
			g_typeEncode = 2;
			break;
		case IDC_RADIO4:	// Q
			g_typeExt = 0;
			EnableWindow(hEdit[0], FALSE);
			SendMessage(hEdit[0], WM_SETTEXT, 0, (LPARAM) "");
			break;
		case IDC_RADIO5:	// P
			g_typeExt = 1;
			EnableWindow(hEdit[0], FALSE);
			SendMessage(hEdit[0], WM_SETTEXT, 0, (LPARAM) "");
			break;
		case IDC_RADIO6:	// w
			g_typeExt = 2;
			EnableWindow(hEdit[0], TRUE);
			break;
		case IDC_RADIO7:	// fXNgbv
			g_typeSaveDir = 0;
			EnableWindow(hEdit[1], FALSE);
			EnableWindow(hBtn, FALSE);
			SendMessage(hEdit[1], WM_SETTEXT, 0, (LPARAM) "");
			break;
		case IDC_RADIO8:	// w
			g_typeSaveDir = 1;
			EnableWindow(hEdit[1], TRUE);
			EnableWindow(hBtn, TRUE);
			break;
		case IDC_BUTTON1:	// Q
            if(HIWORD(wParam) == BN_CLICKED){
				Set_Dir(hDlg, "̧قۑꏊw肵ĉ");
				if(strcmp(g_path, "")){
					SendMessage(hEdit[1], WM_SETTEXT, 0, (LPARAM) g_path);
				}
			}
            break;
		case IDOK:
			{
				char strBuf[MAX_PATH];
				SendMessage(hEdit[0], WM_GETTEXT, sizeof(g_strExt), (LPARAM) g_strExt);
				SendMessage(hEdit[1], WM_GETTEXT, sizeof(g_path), (LPARAM) g_path);
				itoa(g_typeEncode, strBuf, 10);
				WritePrivateProfileString("FILE_ENCODER","TYPE_ENCODE",strBuf,".\\FileEncoder.ini");
				itoa(g_typeExt, strBuf, 10);
				WritePrivateProfileString("FILE_ENCODER","TYPE_EXT_SAVE",strBuf,".\\FileEncoder.ini");
				itoa(g_typeSaveDir, strBuf, 10);
				WritePrivateProfileString("FILE_ENCODER","TYPE_DIR_SAVE",strBuf,".\\FileEncoder.ini");
				WritePrivateProfileString("FILE_ENCODER","EXT_SAVE",g_strExt,".\\FileEncoder.ini");
				WritePrivateProfileString("FILE_ENCODER","DIR_SAVE",g_path,".\\FileEncoder.ini");
			}
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		case IDCANCEL:
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		default:
			return FALSE;
		}
		break;

	case WM_CLOSE:
		DestroyWindow(hDlg);
		PostQuitMessage(0);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

int CALLBACK DlgProc2(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		SetFocus(GetDlgItem(hDlg, IDC_EDIT1));
		return FALSE;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDOK:
			{
				char strBuf[64];
				SendDlgItemMessage(hDlg, IDC_EDIT1, WM_GETTEXT, sizeof(strBuf), (LPARAM) strBuf);
				g_key = atoi(strBuf);
				if(g_key < 1){
					g_key = 1;
				}
			}
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		case IDCANCEL:
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		default:
			return FALSE;
		}
		break;

	case WM_CLOSE:
		DestroyWindow(hDlg);
		PostQuitMessage(0);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

int CALLBACK DlgProc3(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		InitCommonControls();
		SendDlgItemMessage(hDlg, IDC_PROGRESS1, PBM_SETRANGE, 0, MAKELPARAM(0, 100));
		return FALSE;
	
	case WM_SHOWWINDOW:
		_beginthread(Save_File, 0, (void*) hDlg);
		break;
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDOK:
			_endthread();
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		case IDCANCEL:
			_endthread();
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		default:
			return FALSE;
		}
		break;

	case WM_CLOSE:
		DestroyWindow(hDlg);
		PostQuitMessage(0);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	HWND hDlg;
	char strBuf[MAX_PATH];
	char strDef[MAX_PATH];
	strncpy(strDef, __argv[0], sizeof(strDef));
	char *p = strrchr(strDef, '\\');
	if(p)
		strcpy(p, "");
	SetCurrentDirectory(strDef);
	itoa(g_typeEncode, strDef, 10);
	GetPrivateProfileString("FILE_ENCODER","TYPE_ENCODE",strDef,strBuf,sizeof(strBuf),".\\FileEncoder.ini");
	g_typeEncode = atoi(strBuf);
	itoa(g_typeExt, strDef, 10);
	GetPrivateProfileString("FILE_ENCODER","TYPE_EXT_SAVE",strDef,strBuf,sizeof(strBuf),".\\FileEncoder.ini");
	g_typeExt = atoi(strBuf);
	itoa(g_typeSaveDir, strDef, 10);
	GetPrivateProfileString("FILE_ENCODER","TYPE_DIR_SAVE",strDef,strBuf,sizeof(strBuf),".\\FileEncoder.ini");
	g_typeSaveDir = atoi(strBuf);
	strcpy(strDef, "");
	GetPrivateProfileString("FILE_ENCODER","EXT_SAVE",strDef,g_strExt,sizeof(g_strExt),".\\FileEncoder.ini");
	strncpy(strDef, __argv[0], sizeof(strDef));
	p = strrchr(strDef, '\\');
	if(p)
		strcpy(p, "");
	GetPrivateProfileString("FILE_ENCODER","DIR_SAVE",strDef,g_path,sizeof(g_path),".\\FileEncoder.ini");

	if(__argc > 1){	// t@Cst@C Drag & Drop ꂽꍇ
		hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG2), NULL, DlgProc2);
		ShowWindow(hDlg, nCmdShow);
		
		while(GetMessage(&msg, NULL, 0, 0)) {
			if (IsDialogMessage(hDlg, &msg)) continue;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		
		if(g_key > 0){
			if(g_typeSaveDir == 0){
				SHGetSpecialFolderPath(NULL, g_path, CSIDL_DESKTOPDIRECTORY, FALSE);
			}
			if(g_path[strlen(g_path) - 1] == '\\'){
				g_path[strlen(g_path) - 1] = '\0';
			}
			DWORD ret = GetFileAttributes(g_path);
			if(ret != -1 && ret & FILE_ATTRIBUTE_DIRECTORY){
				hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG3), NULL, DlgProc3);
				ShowWindow(hDlg, nCmdShow);
				
				while(GetMessage(&msg, NULL, 0, 0)) {
					if (IsDialogMessage(hDlg, &msg)) continue;
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
				return msg.wParam;
			}
		}
	}

	hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, DlgProc);
	ShowWindow(hDlg, nCmdShow);
	
	while(GetMessage(&msg, NULL, 0, 0)) {
		if (IsDialogMessage(hDlg, &msg)) continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}
